> This page is for API, version 2026-01-01 (Stable) (default).
> For other versions, use one of these documentation indexes:
> - 2026-01-01 (Stable) (default): https://developer.deel.com/api/stable/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.deel.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.deel.com/_mcp/server.

# Upload ATS Candidate CV

POST https://api.letsdeel.com/rest/ats/candidates/{candidate_id}/attachments
Content-Type: multipart/form-data

Upload a CV file for an existing candidate. Use this endpoint after creating a candidate to attach their resume or CV document. This stores the file as the candidate's primary CV attachment for later retrieval and processing.

 **Token scopes**: `ats:write`, `worker:write`

Reference: https://developer.deel.com/api/reference/endpoints/ats/create-ats-candidate-attachment-v-2026-09-16

## Authentication

- `Authorization` header (bearer token, required) — ## Authentication The Deel API uses bearer tokens to authenticate requests. All API calls must be made over HTTPS — calls over plain HTTP or without authentication will fail. ```curl curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \ -H 'Authorization: Bearer YOUR-TOKEN-HERE' ``` [Learn more about authentication](/api/authentication)
- `Authorization` header (bearer token, required) — Standard OAuth2 security scheme based on https://swagger.io/docs/specification/authentication/

## Servers

- `https://api.letsdeel.com/rest` (Production, default)
- `https://api-staging.letsdeel.com/rest` (Demo)

## Request

### Path parameters

- `candidate_id` (string, required) — Unique identifier of the candidate to attach the file to

### Body (multipart/form-data)

This endpoint expects a multipart form.

- `data` (AtsCandidatesCandidateIdAttachmentsPostRequestBodyContentMultipartFormDataSchemaData, required)

## Response

### 201

Successful response with the created attachment data

- `data` (AtsCandidatesCandidateIdAttachmentsPostResponsesContentApplicationJsonSchemaData, required)

## Errors

### 400 Bad Request Error

Operation failed.

- `errors` (list of AtsCandidatesCandidateIdAttachmentsPostResponsesContentApplicationJsonSchemaErrorsItems, required) — List of error objects

### 401 Unauthorized Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 403 Forbidden Error

Forbidden. ATS is not enabled for this organization or insufficient permissions.

- `errors` (list of AtsCandidatesCandidateIdAttachmentsPostResponsesContentApplicationJsonSchemaErrorsItems, required) — List of error objects

### 404 Not Found Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 500 Internal Server Error

Operation failed.

- `errors` (list of AtsCandidatesCandidateIdAttachmentsPostResponsesContentApplicationJsonSchemaErrorsItems, required) — List of error objects

## Types

### AtsCandidatesCandidateIdAttachmentsPostResponsesContentApplicationJsonSchemaData

- `id` (string, required) — Unique identifier for the attachment
- `file_name` (string, required) — Name of the attached file
- `attachable_type_slug` (enum, required) — Type of the entity the file is attached to
  - Allowed values: `CANDIDATE`
- `attachment_type_slug` (enum, required) — Type of the attachment
  - Allowed values: `CV`, `LOGO`, `OFFER_LETTER`, `OTHER`
- `created_at` (string, optional) — Timestamp when the attachment was created
- `updated_at` (string, optional) — Timestamp when the attachment was last updated
- `attachable_id` (string, optional) — Unique identifier of the entity the file is attached to
- `file_content_type` (string, optional, nullable) — Content type of the attached file

### AtsCandidatesCandidateIdAttachmentsPostResponsesContentApplicationJsonSchemaErrorsItems

- `code` (string, required) — Machine-readable error code
- `message` (string, required) — Human-readable error message
- `field` (string, optional) — Request field related to the error, if applicable

### ApiErrorRequest

- `method` (string, optional) — The HTTP method of the failed request
- `url` (string, optional) — The relative URL of the failed request
- `status` (double, optional) — The status code of the response
- `api_req_id` (string, optional) — The request ID of the failed request
- `docs` (string, optional) — A link to the official documentation for the requested endpoint resource
- `source` (string, optional) — The source handler which produced the returned error
- `code` (double, optional) — The code of the source handler which produced the returned error

### ApiError

- `message` (string, optional) — A description of the returned error
- `path` (string, optional) — The JSON path where input validation failed

## Examples

**Request**

```json
{
  "data": {
    "cv": "cv.pdf"
  }
}
```

**Response**

```json
{
  "data": {
    "id": "a1b2c3d4-e5f6-7890-1234-567890abcdef",
    "file_name": "cv.pdf",
    "attachable_type_slug": "CANDIDATE",
    "attachment_type_slug": "CV",
    "created_at": "2024-01-01T00:00:00Z",
    "updated_at": "2024-01-01T00:00:00Z",
    "attachable_id": "a1b2c3d4-e5f6-7890-1234-567890abcdef",
    "file_content_type": "application/pdf"
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.letsdeel.com/rest/ats/candidates/a1b2c3d4-e5f6-7890-1234-567890abcdef/attachments"

payload = "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{\n  \"cv\": \"cv.pdf\"\n}\r\n-----011000010111000001101001--\r\n"
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "multipart/form-data; boundary=---011000010111000001101001"
}

response = requests.post(url, data=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/ats/candidates/a1b2c3d4-e5f6-7890-1234-567890abcdef/attachments';
const form = new FormData();
form.append('data', '{
  "cv": "cv.pdf"
}');

const options = {method: 'POST', headers: {Authorization: 'Bearer <token>'}};

options.body = form;

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/ats/candidates/a1b2c3d4-e5f6-7890-1234-567890abcdef/attachments"

	payload := strings.NewReader("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{\n  \"cv\": \"cv.pdf\"\n}\r\n-----011000010111000001101001--\r\n")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/ats/candidates/a1b2c3d4-e5f6-7890-1234-567890abcdef/attachments")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request.body = "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{\n  \"cv\": \"cv.pdf\"\n}\r\n-----011000010111000001101001--\r\n"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/ats/candidates/a1b2c3d4-e5f6-7890-1234-567890abcdef/attachments")
  .header("Authorization", "Bearer <token>")
  .body("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{\n  \"cv\": \"cv.pdf\"\n}\r\n-----011000010111000001101001--\r\n")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/ats/candidates/a1b2c3d4-e5f6-7890-1234-567890abcdef/attachments', [
  'multipart' => [
    [
        'name' => 'data',
        'contents' => '{
  "cv": "cv.pdf"
}'
    ]
  ]
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/ats/candidates/a1b2c3d4-e5f6-7890-1234-567890abcdef/attachments");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddParameter("undefined", "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{\n  \"cv\": \"cv.pdf\"\n}\r\n-----011000010111000001101001--\r\n", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]
let parameters = [
  [
    "name": "data",
    "value": "{
  \"cv\": \"cv.pdf\"
}"
  ]
]

let boundary = "---011000010111000001101001"

var body = ""
var error: NSError? = nil
for param in parameters {
  let paramName = param["name"]!
  body += "--\(boundary)\r\n"
  body += "Content-Disposition:form-data; name=\"\(paramName)\""
  if let filename = param["fileName"] {
    let contentType = param["content-type"]!
    let fileContent = String(contentsOfFile: filename, encoding: String.Encoding.utf8)
    if (error != nil) {
      print(error as Any)
    }
    body += "; filename=\"\(filename)\"\r\n"
    body += "Content-Type: \(contentType)\r\n\r\n"
    body += fileContent
  } else if let paramValue = param["value"] {
    body += "\r\n\r\n\(paramValue)"
  }
}

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/ats/candidates/a1b2c3d4-e5f6-7890-1234-567890abcdef/attachments")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```